options linesize = 65 ;  
data dog ; 
infile 'C:\Documents and Settings\davidr\My Documents\talks\SemiShortCourse\SAS\dogdata.txt' ; 
input group dog time potassium ;
time2 = time*time ;
run ;
proc gplot ;
plot potassium*time=dog /overlay ;
symbol1 i=j  v=plus color="red";
symbol4 i=j ;
symbol8 i=j v=plus;
symbol12 i=j v=plus;
symbol15 i=j v=plus;
symbol30 i=j v=plus;
run ;
title 'Grizzle and Allen dog data' ;
proc iml ;
use dog var{group dog time time2 potassium};
read all ;
nknots = 3 ;
knots = {4 7 10} ;
plus = J(252,5*nknots) ;
do k=1 to nknots ;
plus[,k] = (time - knots[k])##2 # (time > knots[k]) ;
plus[,3+k] = plus[,k] # (group=1) ;
plus[,6+k] = plus[,k] # (group=2) ;
plus[,9+k] = plus[,k] # (group=3) ;
plus[,12+k] = plus[,k] # (group=4) ;
end ;
varname = 'group' || 'dog' || 'time' || 'time2' || 'potassium' || ('main1':'main3') || ('int1':'int12') ;
outmatrix = group||dog||time||time2||potassium||plus ;
create dog2 from outmatrix [colname=varname] ;
append from outmatrix;
quit ;
proc mixed ;
class group dog ;
model potassium = group time time2 time*group time2*group / s outpred=outdata  ;
random main1-main3 / type=toep(1) s ;
random int1-int12 / type=toep(1) s ;
random dog / type=toep(1) s ;
random time*dog / type=toep(1) s ;
random time*time*dog /type=toep(1) s ;
ods output  solutionr=r solutionf=f;
run ;
proc iml ;
timegrid = 1 + ((1:50))#12/50 ;
timegrid = timegrid` ;
nknots = 3 ;
knots = {4 7 10} ;
plus = J(50,nknots) ;
do k=1 to nknots ;
plus[,k] = (timegrid - knots[k])##2 # (timegrid > knots[k]) ;
end ;
use f var{Estimate} ; read all ;estf=Estimate ; 
use r var{Estimate} ; read all ;estr = Estimate ;
group1 = estf[1] + estf[2] + (estf[6]+estf[8])#timegrid + (estf[7]+estf[12])#timegrid##2
+ (estr[1]+estr[4])#plus[,1] +(estr[2]+estr[5])#plus[,2] +(estr[3]+estr[6])#plus[,3];

group2 = estf[1] + estf[3] + (estf[6]+estf[9])#timegrid + (estf[7]+estf[13])#timegrid##2
+ (estr[1]+estr[7])#plus[,1] +(estr[2]+estr[8])#plus[,2] +(estr[3]+estr[9])#plus[,3];

group3 = estf[1] + estf[4] + (estf[6]+estf[10])#timegrid + (estf[7]+estf[14])#timegrid##2
+ (estr[1]+estr[10])#plus[,1] +(estr[2]+estr[11])#plus[,2] +(estr[3]+estr[12])#plus[,3];

group4 = estf[1] + estf[5] + (estf[6]+estf[11])#timegrid + (estf[7]+estf[15])#timegrid##2
+ (estr[1]+estr[13])#plus[,1] +(estr[2]+estr[14])#plus[,2] +(estr[3]+estr[15])#plus[,3];

varname = 'group1'|| 'group2'|| 'group3' ||'group4' ||'timegrid';
outmatrix = group1||group2||group3||group4||timegrid ;
create dog3 from outmatrix [colname=varname] ;
append from outmatrix ;
quit ;
proc gplot data=dog3 ;
plot group1*timegrid group2*timegrid group3*timegrid group4*timegrid/ overlay legend ;
symbol1 v=star i=join color="red";
symbol2 v=plus i=join color="blue" ;
symbol3 v=star i=join color="green";
symbol4 v=plus i=join color= "red" ;
run ;
