options linesize = 65 ;  
data lidar ; 
infile 'C:\Documents and Settings\davidr\My Documents\talks\SemiShortCourse\SAS\lidar.txt' ; 
input range logratio ;
run ;
title 'LIDAR Penalized Spline' ;
proc iml ;
use lidar var{range logratio};
read all ;
nknots = 24 ;
rr = (1:nknots) * (221/(1+nknots)) ;
rr = int(rr) ;
knots = range[rr] ;
plus = J(221,nknots) ;
do k=1 to nknots ;
plus[,k] = (range - knots[k])##2 # (range > knots[k]) ;
end ;
varname = 'range' || 'logratio' || ('z1':'z24') ;
outmatrix = range||logratio||plus ;
create lidar2 from outmatrix [colname=varname] ;
append from outmatrix;
proc mixed ;
model logratio = range|range / outpred=outdata  ;
random z1-z24 / type=toep(1) s ;
run ;
proc gplot ;
plot logratio*range=1 pred*range=2/overlay;
symbol1 v=star i=none color=red;
symbol2 v=none i=join color=blue;
run ;