options linesize = 65 ;
data onion ;
infile 'C:\Documents and Settings\davidr\My Documents\talks\SemiShortCourse\SAS\onion.txt' ;
input obs density yield location;
run ;
title 'Onion Yields - Penalized Spline' ;
proc iml ;
use onion var{obs density yield location};
read all ;
location = location -1 ;
nknots = 20 ;
degree = 1 ;
rr = (1:nknots) * (84/(1+nknots)) ;
rr = int(rr) ;
knots = density[rr] ;
plus = J(84,nknots) ;
interact = plus||plus ;
do k=1 to nknots ;
plus[,k] = ((density - knots[k])##degree) # (density > knots[k]) ;
interact[,2*k-1] = plus[,k]#(location<.5) ;
interact[,2*k] = plus[,k]#(location> .5) ;
end ;
print interact ;
varname = 'obs' || 'density' || 'yield' || 'location' || ('z1':'z20') || ('interact1':'interact40') ;
outmatrix = obs ||density || yield || location || plus|| interact ;
create lidar2 from outmatrix [colname=varname] ;
append from outmatrix;
proc mixed method=REML ;
class location ;
model yield = density density*density location density*location location*density*density / outpred=outdata  ;
random z1-z10 / type=toep(1)  ;
random interact1-interact20/ type=toep(1) ;
data outdata ;
set outdata ;
Pred_interaction = pred ;
drop pred ;
run ;
proc mixed ;
model yield = density density*density location  / outpred=outdata2  ;
random z1-z10 / type=toep(1)  ;
run ;
data outdata2 ;
set outdata2 ;
Pred_additive = pred ;
drop pred ;
run ;
data outdata ;
merge outdata outdata2 ;
by obs ;
run ;
proc gplot ;
legend1 label = none position=inside;
symbol1 v=plus i=none color=red;
symbol2 v=star i=none color=blue;
plot pred_additive*density=1 pred_interaction*density=2 /overlay legend=legend1;
run ;
proc gplot ;
symbol1 v=plus i=none color=red;
symbol2 v=star i=none color=blue;
plot yield*density=location;
run ;
